<?php

namespace app\admin\controller;

use app\common\model\ai\Config;

class Aiconfig extends Botbase
{
    /**
     * @var Config
     */
    protected $model;
    /**
     * @var array
     */
    private $tabList;
    /**
     * @var array
     */
    private $aiDrivers;

    public function initialize()
    {
        parent::initialize(); // TODO: Change the autogenerated stub
        $this->model = new Config();
        $this->aiDrivers = [
            'weixin' => '微信AI',
            'qyk' => '青云客',
            'gpt' => 'chatGpt'
        ];
        $this->tabList = [

        ];
    }

    /**
     * 设置
     * @return mixed
     * @throws \think\Exception
     * @author: fudaoji<fdj@kuryun.cn>
     */
    public function index(){
        $tip = "<ul><li>微信OpenAi: <a target='_blank' href='https://openai.weixin.qq.com/'>https://openai.weixin.qq.com/</a></li>
<li>青云客Ai: <a target='_blank' href='http://api.qingyunke.com/'>http://api.qingyunke.com/</a></li>
</ul>";
        $settings = $this->model->getConf(['bot_id' => $this->bot['id']]);
        if(!empty($settings['wxids'])){
            $settings['wxids'] = explode(',', $settings['wxids']);
        }
        if(empty($settings)){
            $settings = [
                'driver' => 'weixin',
                'switch' => 1
            ];
        }

        $builder = new FormBuilder();
        $builder->setPostUrl(url('savePost'))
            ->setTip($tip)
            ->addFormItem('basic_legend', 'legend', '基础配置','基础配置' )
            ->addFormItem('id', 'hidden', 'id', 'id')
            ->addFormItem('switch', 'radio', '开启', '是否开启', [1=>'是', 0 => '否'])
            ->addFormItem('driver', 'radio', 'AI驱动', 'AI驱动', $this->aiDrivers)
            ->addFormItem('wxids', 'chosen_multi', '作用对象', '指定的作用对象才会生效', $this->getMembers(), 'required')
            ->addFormItem('weixin_legend', 'legend', '微信智能对话','微信智能对话' )
            ->addFormItem('wx_appid', 'text', 'Appid', '微信智能对话的Appid')
            ->addFormItem('wx_token', 'text', 'Token', '微信智能对话的Token')
            ->addFormItem('wx_encoding_aes_key', 'text', 'EncodingAesKey', '微信智能对话的EncodingAesKey')
            ->addFormItem('qyk_legend', 'legend', '青云客','青云客' )
            ->addFormItem('qyk_appid', 'text', 'Appid', '填0就好')
            ->addFormItem('gpt_legend', 'legend', 'chatGpt','chatGpt' )
            ->addFormItem('gpt_appid', 'text', 'OpenaiId', 'OpenaiId的OpenaiId')
            ->setFormData($settings);
        return $builder->show();
    }

    public function savePost($jump_to = '/undefined', $data = [])
    {
        $jump_to = url('index');
        $post_data = input('post.');
        unset($post_data['__token__']);
        foreach ($post_data as $k => $v){
            if($config = $this->model->getOneByMap(['bot_id' => $this->bot['id'], 'key' => $k],  true, true)){
                $this->model->updateOne(['id' => $config['id'], 'value' => $v]);
            }else{
                $this->model->addOne([
                    'admin_id' => $this->adminInfo['id'],
                    'bot_id' => $this->bot['id'],
                    'key' => $k,
                    'value'=> $v
                ]);
            }
        }
        $this->model->getConf(['bot_id' => $this->bot['id']], '', true);
        $this->success('数据保存成功', $jump_to);
    }
}